library test.encode;

import 'package:test/test.dart';
import 'package:jaguar_jwt/jaguar_jwt.dart';

final key = 'secret';

main() {
  group('Encoding', () {
    test('Nopayload', () {
      final claimSet = new JwtClaim(
          issuer: 'teja',
          subject: '1234567890',
          audience: ["admin", "students"],
          issuedAt: new DateTime.fromMillisecondsSinceEpoch(1481842800000));
      String token = issueJwtHS256(claimSet, key);
      expect(token,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOlsiYWRtaW4iLCJzdHVkZW50cyJdLCJleHAiOjg2NDAwLCJpYXQiOiIyMDE2LTEyLTE2VDAwOjAwOjAwLjAwMCIsImlzcyI6InRlamEiLCJzdWIiOiIxMjM0NTY3ODkwIn0=.udEDnUW199M3jlm_bl0BqSADGEFE1TeeV5Jh26vMvQM=');
    });

    test('With payload', () {
      final claimSet = new JwtClaim(
          issuer: 'teja',
          subject: '1234567890',
          audience: ["admin", "students"],
          issuedAt: new DateTime.fromMillisecondsSinceEpoch(1481842800000),
          payload: {"k": "v"});
      String token = issueJwtHS256(claimSet, key);
      expect(token,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOlsiYWRtaW4iLCJzdHVkZW50cyJdLCJleHAiOjg2NDAwLCJpYXQiOiIyMDE2LTEyLTE2VDAwOjAwOjAwLjAwMCIsImlzcyI6InRlamEiLCJwbGQiOnsiayI6InYifSwic3ViIjoiMTIzNDU2Nzg5MCJ9.hilXwGlJ5xMRQ7vTsCHiBwHRa-9xVb4NEqDg4Ufsui0=');
    });
  });
}
